searchNodes=[{"doc":"Freshness A minimal pooling wrapper on top of Mint. It is meant as an alternative pooling option (other than e.g. Mojito) that should in theory allow for more flexibility when using Mint options. It returns raw Mint responses back to callers. Installation Install the package by adding freshness to your list of dependencies in mix.exs. If you need to make https requests then you need to add the castore dependency too (as with Mint) def deps do [ {:castore, &quot;~&gt; 0.1.0&quot;}, {:freshness, &quot;~&gt; 0.2.0&quot;} ] end How to use Freshness needs an Registry to look up workers. For each additional destination you need make requests to you need to add an additional supervisor to handle them. Add the following lines to your application.ex file (or under any other Supervisor you want). You can also take a look at the Mint connection options def start (_, _) do # create 2 different pools for 2 separate endpoints # name can be any term, and will be used to identify the correct pool # arguments are pool_name, no_of_workers_in_pool, scheme, domain, port, mint_connection_options config = Freshness.Config.new(&quot;google&quot;, 5, :http, &quot;google.com&quot;, 80, []) config2 = Freshness.Config.new(:bing, 5, :http, &quot;bing.com&quot;, 80) children = [ # freshness expect to find a :unique registry named Registry.Freshness. If you are already # using the Registry module in your app, you will need to specify an id as follows: Supervisor.child_spec({Registry, keys: :unique, name: Freshness.Config.registry_name()}, id: Freshness.Config.registry_name() ), # again, because we&#39;re specifying the Freshness.Supervisor module twice, we need to also provide a distinct id Supervisor.child_spec({Freshness.Supervisor, config}, id: config1.name), Supervisor.child_spec({Freshness.Supervisor, config2}, id: config2.name) ] ... Supervisor.start_link(children, strategy: :one_for_one) end Inside your application you can now issue requests to the configured endpoints {:ok, %Freshness.Response{}} = Freshness.get(&quot;google&quot;, &quot;/&quot;) ... {:ok, %Freshness.Response{}} = Freshness.get(:bing, &quot;/&quot;) Advanced usage If you do not know the destinations at runtime, you can start the Registry in your application.ex file as above, but start the Freshness.Supervisors under a DynamicSupervisor How it works Freshness works by creating pools of workers that each holds one or more connections to a given destination. Connections are opened lazily but are re-used, but more may be created on the spot if a given worker cannot satisfy a request. Connecting and HTTP1,2 protocol parsing and buffering are all Mint. Right now the number of open connections each worker can open is unbound. Freshness discovers the worker to pass a request to using the Registry module and an :atomics counter to round robin the requests to each worker in the pool Is this production ready? Not by a long shot. It&#39;s barely tested. Perhaps it will be someday- right now it just serves as an exploration project.","ref":"Freshness.html","title":"Freshness","type":"module"},{"doc":"Make a GET request using the given pool","ref":"Freshness.html#get/3","title":"Freshness.get/3","type":"function"},{"doc":"Make a request to the configured Freshness pool","ref":"Freshness.html#request/5","title":"Freshness.request/5","type":"function"},{"doc":"Freshness configuration options","ref":"Freshness.Config.html","title":"Freshness.Config","type":"module"},{"doc":"","ref":"Freshness.Config.html#new/6","title":"Freshness.Config.new/6","type":"function"},{"doc":"","ref":"Freshness.Config.html#registry_name/0","title":"Freshness.Config.registry_name/0","type":"function"},{"doc":"","ref":"Freshness.Config.html#t:pool_name/0","title":"Freshness.Config.pool_name/0","type":"type"},{"doc":"name: the name to register a freshness tree under. Used with Elixir.Registry to address open connections to a perticular endpoint. count: number of servers in the pool index: the i-th process to register under this name mint: Mint configuration options for opening connections (scheme, port, host, options)","ref":"Freshness.Config.html#t:t/0","title":"Freshness.Config.t/0","type":"type"},{"doc":"Mint connection configuration options","ref":"Freshness.Config.MintConfig.html","title":"Freshness.Config.MintConfig","type":"module"},{"doc":"","ref":"Freshness.Config.MintConfig.html#t:t/0","title":"Freshness.Config.MintConfig.t/0","type":"type"},{"doc":"","ref":"Freshness.PendingRequest.html","title":"Freshness.PendingRequest","type":"module"},{"doc":"A simple pool backed by a :queue to store connections Usage To create a pool call the new/4 function pool = Freshness.Pool.new(:http, &quot;google.com&quot;, 80) To checkout a connection from the pool use the checkout/1 function. Note: if there are no connections in the pool a new one will be created and returned {:ok, pool, connection} = Freshness.Pool.checkout(pool) You may also get an error if there are no connections in the pool and a new connection cannot be opened {:error, error} = Freshness.Pool.checkout(pool) To return a connection back to the pool use the checkin/2 function pool = Freshness.Pool.checkin(pool, connection)","ref":"Freshness.Pool.html","title":"Freshness.Pool","type":"module"},{"doc":"","ref":"Freshness.Pool.html#checkin/2","title":"Freshness.Pool.checkin/2","type":"function"},{"doc":"","ref":"Freshness.Pool.html#checkout/1","title":"Freshness.Pool.checkout/1","type":"function"},{"doc":"","ref":"Freshness.Pool.html#empty?/1","title":"Freshness.Pool.empty?/1","type":"function"},{"doc":"","ref":"Freshness.Pool.html#length/1","title":"Freshness.Pool.length/1","type":"function"},{"doc":"","ref":"Freshness.Pool.html#new/4","title":"Freshness.Pool.new/4","type":"function"},{"doc":"","ref":"Freshness.Pool.html#t:t/0","title":"Freshness.Pool.t/0","type":"type"},{"doc":"","ref":"Freshness.Response.html","title":"Freshness.Response","type":"module"},{"doc":"","ref":"Freshness.Response.html#generate_response/1","title":"Freshness.Response.generate_response/1","type":"function"},{"doc":"","ref":"Freshness.Response.html#t:t/0","title":"Freshness.Response.t/0","type":"type"},{"doc":"A genserver module holding open connections to the same (host, port, protocol) socket. It is meant as a light-weight pooling mechanism that exposes raw mint replies","ref":"Freshness.Server.html","title":"Freshness.Server","type":"module"},{"doc":"Returns a specification to start this module under a supervisor. See Supervisor.","ref":"Freshness.Server.html#child_spec/1","title":"Freshness.Server.child_spec/1","type":"function"},{"doc":"","ref":"Freshness.Server.html#request/5","title":"Freshness.Server.request/5","type":"function"},{"doc":"","ref":"Freshness.Server.html#start_link/1","title":"Freshness.Server.start_link/1","type":"function"},{"doc":"","ref":"Freshness.Server.html#via_tuple/2","title":"Freshness.Server.via_tuple/2","type":"function"},{"doc":"","ref":"Freshness.Server.html#t:t/0","title":"Freshness.Server.t/0","type":"type"},{"doc":"The supervisor responsible for a pool of workers. Check the README for instructions on how to setup.","ref":"Freshness.Supervisor.html","title":"Freshness.Supervisor","type":"module"},{"doc":"Returns a specification to start this module under a supervisor. See Supervisor.","ref":"Freshness.Supervisor.html#child_spec/1","title":"Freshness.Supervisor.child_spec/1","type":"function"},{"doc":"","ref":"Freshness.Supervisor.html#start_link/1","title":"Freshness.Supervisor.start_link/1","type":"function"}]